include HighLight.inc

.code
align 16
DllEntry proc hInst:HINSTANCE,reason:DWORD,reserved1:DWORD

	.if reason == DLL_PROCESS_ATTACH
		mov gsi.GdiplusVersion,1
		mov gsi.DebugEventCallback,0
		mov gsi.SuppressBackgroundThread,0
		mov gsi.SuppressExternalCodecs,0
		invoke GdiplusStartup,ADDR gtkn,ADDR gsi,0
		m2m	hInstance,hInst
		invoke GdipCreateSolidFill,ARGB_DEFAULT_WHOLEWORD,ADDR brHighLight.brWord
		invoke GdipCreateSolidFill,ARGB_DEFAULT_WHOLEWORDI,ADDR brHighLight.brWordI
		invoke GdipCreateSolidFill,ARGB_DEFAULT_PARTIAL,ADDR brHighLight.brChars
		invoke GdipCreateSolidFill,ARGB_DEFAULT_PARTIALI,ADDR brHighLight.brCharsI
	.elseif reason == DLL_PROCESS_DETACH
		invoke GdipDeleteBrush,brHighLight.brWord
		invoke GdipDeleteBrush,brHighLight.brWordI
		invoke GdipDeleteBrush,brHighLight.brChars
		invoke GdipDeleteBrush,brHighLight.brCharsI
		invoke GdiplusShutdown,gtkn
	.endif
	mov eax,TRUE
	ret

DllEntry Endp

align 16
InstallAddin proc EXPORT hWin:DWORD

	;Get pointer to handles struct
	mov pHandles,rv(SendMessage,hWin,AIM_GETHANDLES,0,0)

	;Get pointer to proc struct
	mov pAddinProcs,rv(SendMessage,hWin,AIM_GETPROCS,0,0)
	
	;Get pointer to data struct
	mov pAddinData,rv(SendMessage,hWin,AIM_GETDATA,0,0)

	; Allocate a new menu id
	mov IDAddIn,rv(SendMessage,hWin,AIM_GETMENUID,0,0)

	mov eax,pAddinData
	add	eax,ADDINDATA.szRadASMIni
	invoke SettingsLoadIni,eax

	mov eax,offset hook
	ret

InstallAddin Endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
; This proc handles messages sent from RadASM to our dll
; Return TRUE to prevent RadASM and other dll's from
; processing command.
align 16
AddinProc proc EXPORT hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL RetVal:DWORD
	
	mov	RetVal,TRUE

	.if uMsg == AIM_COMMAND
		movzx eax,WORD ptr wParam
		.if eax == IDAddIn && WORD ptr wParam+2 == BN_CLICKED
			mov eax,pHandles
			invoke DialogBoxParamW,hInstance,IDD_DLG1,[eax].ADDINHANDLES.hWnd,addr DialogProc,NULL
			
			; Your addin has been selected
			mov eax,TRUE
			ret
		.endif
	.elseif uMsg == AIM_UNHOOK
		mov eax,hWin
		mov	ecx,wParam
		mov	edx,lParam
		.if eax == hEdit1 && ecx == pOrgEditProc1
			;Remove the hook from the chain
			mov pOrgEditProc1,edx
			mov	eax,TRUE
			ret
		.elseif eax == hEdit2 && ecx == pOrgEditProc2
			;Remove the hook from the chain
			mov	pOrgEditProc2,edx
			mov	eax,TRUE
			ret
		.endif
	.elseif uMsg == AIM_CLOSE
		;Undo subclassing
		.if pOrgEditProc1
			invoke UnHook,hEdit1,offset RAEditProc,pOrgEditProc1
			mov	pOrgEditProc1,0
		.endif
		.if pOrgEditProc2
			invoke UnHook,hEdit2,offset RAEditProc,pOrgEditProc2
			mov pOrgEditProc2,0
		.endif
		mov edx,pHandles
		invoke DeleteMenu,[edx].ADDINHANDLES.hMenu,IDAddIn,MF_BYCOMMAND
		xor eax,eax
		mov IDAddIn,eax
	.elseif uMsg == AIM_MDIACTIVATE
	; This message is sendt when a mdi child is activated or deactivated.
	; Always return FALSE. hWin=Mdi child window,wParam and lParam as M_MDIACIVATE
	
		.if hWin
			mov eax,pHandles
			.if  rv(GetWindowLong,[eax].ADDINHANDLES.hEdt,GWL_ID) == ID_EDITCODE ;ID_EDIT
				mov	eax,wParam
				.if eax == hWin && pOrgEditProc1
					;Unsubclass the RAEdit windows
					invoke UnHook,hEdit1,offset RAEditProc,pOrgEditProc1
					invoke UnHook,hEdit2,offset RAEditProc,pOrgEditProc2
					mov pOrgEditProc1,0				;Set as unhooked
					mov pOrgEditProc2,0				;Set as unhooked
				.else
					
					invoke GetWindowLong,lParam,GWL_USERDATA
					mov	lpEDIT_struct,rv(GetWindowLong,eax,DWL_MSGRESULT)
					m2m	hEdit1,[eax].EDIT.edta.hwnd
					m2m	hEdit2,[eax].EDIT.edtb.hwnd

					;=======================================================
					; Check the richedit version
					;=======================================================
					invoke SendMessage,hEdit1,EM_SETTYPOGRAPHYOPTIONS,TO_SIMPLELINEBREAK,TO_SIMPLELINEBREAK
					.if rv(SendMessage,hEdit1,EM_GETTYPOGRAPHYOPTIONS,1,1) == 0		; means this message is not processed
						mov RichEditVersion,2
					.else
						mov RichEditVersion,3
						;=============================================================================
						; Make it emulate system edit control so the text color update doesn't  take very long
						;=============================================================================
						invoke SendMessage,hEdit1,EM_SETEDITSTYLE,SES_EMULATESYSEDIT,SES_EMULATESYSEDIT
						invoke SendMessage,hEdit2,EM_SETEDITSTYLE,SES_EMULATESYSEDIT,SES_EMULATESYSEDIT
					.endif
	
					;Subclass the RAEdit child windows
					mov pOrgEditProc1,rv(SetWindowLong,hEdit1,GWL_WNDPROC,ADDR RAEditProc)
					mov pOrgEditProc2,rv(SetWindowLong,hEdit2,GWL_WNDPROC,ADDR RAEditProc)
					mov	eax, TRUE
					ret
				.endif
			.endif
		.endif
	.elseif	uMsg == AIM_RASELCHANGE	;AIM_EDITSELCHANGE
	;This message is sendt when a ID_EDITCODE window has a selection change.
	;Always return FALSE.
	;hWin=Mdi child window,wParam=lpTABMEM,lParam=lpRASELCHANGE

		mov eax,lParam
		.if [eax].RASELCHANGE.seltyp == SEL_TEXT
			mov edx,[eax].RASELCHANGE.chrg.cpMin
			mov	vBeginSel,edx
			mov	ecx,[eax].RASELCHANGE.chrg.cpMax
			sub	ecx,edx
			.if SIGN?
				neg ecx
				m2m vBeginSel,[eax].RASELCHANGE.chrg.cpMax
			.endif
			mov sizeHL,ecx
			
			.if	sizeHL < SIZEOF szHL || !sizeHL
				mov	eax,wParam
				invoke	SendMessage,[eax].TABMEM.hedt,EM_GETSELTEXT,NULL,ADDR szHL
				xor ecx,ecx
				.while	ecx < sizeHL
					movzx eax,BYTE ptr szHL[ecx]
					.if	eax < 23h || eax == ',' || eax == '(' || eax == ')' || eax == ':' || eax == ';' || eax == "'" || eax == '<'  || eax == '>' || eax == '%' || eax == '/' || eax == '+' || eax == '-' || eax == '*' || eax == '&' || eax == '|' || eax == '=' || eax == 60h || eax == '~' || eax == 7fh || eax == '{' || eax == '}' || eax == '.'
						mov	sizeHL,0
						.break
					.endif
					inc ecx
				.endw

				mov	eax,wParam
				invoke SendMessage,[eax].TABMEM.hedt,REM_REPAINT,1,0
			.else
				mov	sizeHL,0
			.endif

		.endif
		return	TRUE
	.elseif uMsg == AIM_MENUUPDATE
		invoke UpdateMenu,wParam
	.endif
	xor eax,eax
	ret
AddinProc Endp


align 16
UnHook proc hWin:HWND,pThisProc:DWORD,pOldProc:DWORD

	invoke GetWindowLong,hWin,GWL_WNDPROC
	.if eax == pThisProc
		invoke SetWindowLong,hWin,GWL_WNDPROC,pOldProc
	.endif
	ret

UnHook endp

align 16
RAEditProc proc uses edi esi ebx hWnd:DWORD, uMsg:DWORD, wParam:DWORD,lParam:DWORD
	LOCAL txtrange:TEXTRANGE
	LOCAL rect:RECT
	LOCAL pchrFirst:DWORD
	LOCAL hREdit:DWORD
	LOCAL hdc:DWORD
	LOCAL hFont:DWORD
	LOCAL cbBuffer:DWORD
	LOCAL graphics:PVOID
	LOCAL pen:PVOID
	LOCAL brush:PVOID
	LOCAL pBuffer:PBYTE
	LOCAL ccRange:SDWORD
	LOCAL chrLeading:DWORD
	LOCAL chrAfter:DWORD	
	
	.if uMsg == WM_PAINT
		mov hdc,rv(GetDC,hWnd)
		mov eax,pHandles
		mov	eax,[eax].ADDINHANDLES.hEdt
		mov	hREdit,eax

		invoke HideCaret,hWnd
		invoke InvalidateRect,hWnd,0,0
		invoke CallWindowProc,pOrgEditProc1,hWnd,uMsg,wParam,lParam
		push eax

		.if sizeHL

			invoke SendMessage,hREdit,EM_GETRECT,0,addr rect

			;/* obtain first visible char.*/
			mov txtrange.chrg.cpMin,rv(SendMessage,hREdit,EM_LINEINDEX,rv(SendMessage,hREdit,EM_GETFIRSTVISIBLELINE ,0,0),0)
			mov pchrFirst,eax

			mov txtrange.chrg.cpMax,rv(SendMessage,[hREdit],EM_CHARFROMPOS,0,addr rect.right)

			sub eax,pchrFirst
			inc eax
			mov cbBuffer,eax

			.if cbBuffer
				.if ASM(mov pBuffer,alloc(cbBuffer))
					
					; Get the visible text into buffer					
					mov edi,pBuffer
					mov	txtrange.lpstrText,edi
					mov ccRange,rv(SendMessage,hREdit,EM_GETTEXTRANGE,0,ADDR txtrange)
					.if ccRange
						
						mov eax,pHandles
						mov hFont,rv(SelectObject,hdc,[eax].ADDINHANDLES.racf.hFont)
						
						invoke GdipCreateFromHDC,hdc,ADDR graphics
						invoke GdipSetPageUnit,graphics,UnitPixel
						
						xor ecx,ecx
						.while ecx < ccRange
							
							;/* scan for first matching char. (case insensitiv) */
							xor esi,esi
							movzx eax,BYTE ptr szHL[0]
							.if eax >= 'A' && eax <= 'Z'
								mov esi,20h
							.elseif eax >= 'a' && eax <= 'z'
								mov esi,-20h
							.endif
							lea esi,[esi+eax]
						@@: movzx edx,BYTE ptr [edi+ecx]
							lea ecx,[ecx+1]
							cmp edx,eax
							je @F
							cmp edx,esi
							je @F
							cmp ecx,ccRange
							jb @B
							;/* no matching char. found - nothing to draw */
							.break .if !CARRY?	; jae
						@@:	
							.if ecx >= 2
								movzx eax,BYTE ptr [edi+ecx-2]
								mov chrLeading,eax
							.else
								mov chrLeading,','
							.endif
							
							
							;/* save buffer index */
							push ecx
							lea ecx,[ecx-1]
						
							; cmpare strings (case insenitiv)
							xor esi,esi
							xor edx,edx
						@@:	movzx eax,BYTE ptr [edi+ecx]
							movzx ebx,BYTE ptr szHL[edx]
							mov szOrigin[edx],al
							lea ecx,[ecx+1]
							lea edx,[edx+1]
							.if eax != ebx
								mov esi,1
							.endif
							.if eax >= 'A' && eax <= 'Z'
								add eax,20h
							.endif
							.if ebx >= 'A' && ebx <= 'Z'
								add ebx,20h
							.endif
							.if eax != ebx
								pop ecx
								.continue
							.endif
							cmp edx,sizeHL
							jae @F
							cmp ecx,ccRange
							jb @B
							add esp,4
							.break
						@@:
							.if ecx < ccRange
								movzx eax,BYTE ptr [edi+ecx]
								mov chrAfter,eax
							.else
								mov chrAfter,','
							.endif
						
							mov ebx,rv(IsSeparator,chrLeading)
							invoke IsSeparator,chrAfter
							.if esi
								.if eax && ebx
									m2m brush,brHighLight.brWordI
								.else	
									m2m brush,brHighLight.brCharsI
								.endif
							.else
								.if eax && ebx
									m2m brush,brHighLight.brWord
								.else	
									m2m brush,brHighLight.brChars
								.endif
							.endif
							
							
							;/* get index for curr. string */
							mov edx,DWORD ptr [esp]
							lea edx,[edx-1]
							add edx,pchrFirst
							
							;/* highlight when not selction*/
							.if edx != vBeginSel
								
								;/* get rect for curr. string */
								invoke SendMessage,hREdit,EM_POSFROMCHAR,addr rect,edx
		
								invoke GetTextExtentPoint32,hdc,ADDR szOrigin[0],sizeHL,ADDR rect.right
								
								mov edx,DWORD ptr [esp]
								lea edx,[edx-1]
								.if	edx != vBeginSel
									invoke GdipFillRectangleI,graphics,brush,rect.left,rect.top,rect.right,rect.bottom
								.endif
							.endif
							
							;/* update buffer index */
							pop ecx
							mov	eax,sizeHL
							lea ecx,[ecx+eax-1]
						.endw
		
						invoke GdipDeleteGraphics,graphics

						invoke SelectObject,hdc,hFont

					.endif
					free pBuffer
				.endif
			.endif
		.endif
		invoke ShowCaret,hWnd
		invoke ReleaseDC,hWnd,hdc
		pop eax
	.elseif uMsg == WM_CLOSE
		invoke SetWindowLong,hWnd,GWL_WNDPROC,pOrgEditProc1
		invoke CallWindowProc,pOrgEditProc1,hWnd,uMsg,wParam,lParam
	.else
		invoke CallWindowProc,pOrgEditProc1,hWnd,uMsg,wParam,lParam
	.endif
	ret
RAEditProc endp

align 16
IsSeparator proc USES EDX ECX char:DWORD
	lea edx,szSeperators
	xor	ecx,ecx
	.if !char
		mov eax,1
		ret
	.endif
	.repeat
		movzx eax,BYTE ptr [edx+ecx]
		.break .if	!eax
		.if eax == char
			mov eax,1
			ret
		.endif
		lea ecx,[ecx+1]
	.until 0

	ret
IsSeparator endp

align 16
UpdateMenu proc hMnu:HMENU
LOCAL mii:MENUITEMINFO

	mov mii.cbSize,sizeof MENUITEMINFO
	mov mii.fMask,MIIM_SUBMENU
	mov edx,pHandles
	invoke GetMenuItemInfo,[edx].ADDINHANDLES.hMenu,IDM_TOOLS,FALSE,addr mii
	invoke AppendMenu,mii.hSubMenu,MF_STRING,IDAddIn,chr$('HighLight')
	ret

UpdateMenu endp

align 16
DialogProc proc uses esi ebx hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL dwID:DWORD
LOCAL dwEdit:DWORD
LOCAL hEdit:HWND
LOCAL szBuffer[128]:BYTE
LOCAL color  :DWORD
LOCAL hdc:DWORD
LOCAL hID:DWORD
LOCAL argbColor:DWORD
LOCAL rgbColor:DWORD

	.if uMsg == WM_INITDIALOG
		;/* subcalss static controls */
		xor ebx,ebx
		.while ebx <= 3
			mov esi,rv(GetDlgItem,hDlg,ADDR [ebx+IDC_STC_0])
			invoke GetWindowLong,esi,GWL_WNDPROC
			mov static0.pWndProc[ebx*SIZEOF STATIC_SUBCALSS],eax
			invoke SetWindowLong,esi,GWL_USERDATA,ADDR static0[ebx*SIZEOF STATIC_SUBCALSS]
			invoke SetWindowLong,esi,GWL_WNDPROC,OFFSET StaticProc
			inc ebx
		.endw

		;/* set scroll postion/range and edit's text */
		xor ebx,ebx
		.while ebx < SIZEOF brHighLight/4
			mov esi,rv(GetDlgItem,hDlg,ADDR [ebx+IDC_SCB_0])
			invoke SetScrollRange,esi,SB_CTL,0,255,0
			invoke GdipGetSolidFillColor,DWORD ptr brHighLight[ebx*4],ADDR argbColor
			mov eax,argbColor
			shr eax,3*8
			push eax
			invoke SetScrollPos,esi,SB_CTL,eax,1
			invoke SetWindowLong,esi,GWL_USERDATA,ADDR brHighLight[ebx*4]
			mov esi,rv(GetDlgItem,hDlg,ADDR [ebx+IDC_EDT_0])
			pop eax
			invoke SetWindowText,esi,ubyte$(al)
			invoke SetWindowLong,esi,GWL_USERDATA,ADDR brHighLight[ebx*4]
			inc ebx
		.endw
		;/* save old colors */
		invoke GdipGetSolidFillColor,brHighLight.brWord,ADDR brHighLightSave.brWord
		invoke GdipGetSolidFillColor,brHighLight.brWordI,ADDR brHighLightSave.brWordI
		invoke GdipGetSolidFillColor,brHighLight.brChars,ADDR brHighLightSave.brChars
		invoke GdipGetSolidFillColor,brHighLight.brCharsI,ADDR brHighLightSave.brCharsI
		
	.elseif uMsg == WM_HSCROLL
		mov ebx,rv(GetWindowLong,lParam,GWL_USERDATA)
		mov esi,rv(GetScrollPos,lParam,SB_CTL)
		
		.if WORD ptr wParam == SB_LINELEFT	
			dec esi			
		.elseif WORD ptr wParam == SB_LINERIGHT	
			inc esi
		.elseif WORD ptr wParam == SB_PAGELEFT
			sub esi,26
			.if CARRY?
				xor esi,esi
			.endif
		.elseif WORD ptr wParam == SB_PAGERIGHT
			add esi,26
			.if esi & not 0ffh
				mov esi,0ffh
			.endif
		.elseif WORD ptr wParam == SB_THUMBTRACK
			movzx esi,WORD ptr wParam+2
		.endif

		invoke GdipGetSolidFillColor,DWORD ptr [ebx],ADDR argbColor
		invoke SetScrollPos,lParam,SB_CTL,esi,1
		mov eax,argbColor
		and eax,0ffffffh
		shl esi,3*8
		or esi,eax
		invoke GdipSetSolidFillColor,DWORD ptr [ebx],esi
		sub ebx,OFFSET brHighLight.brWord
		shr ebx,2
		invoke GetDlgItem,hDlg,ADDR [ebx+IDC_EDT_0]
		xchg eax,esi
		shr eax,3*8
		invoke SetWindowText,esi,ubyte$(al)
		invoke GetDlgItem,hDlg,ADDR [ebx+IDC_STC_0]
		invoke InvalidateRect,eax,0,1
		
		mov eax,pAddinData
		invoke SettingsSaveIni,ADDR [eax].ADDINDATA.szRadASMIni

	.elseif uMsg == WM_COMMAND
		.if WORD ptr wParam+2 == BN_CLICKED
			.if WORD ptr wParam == IDC_BTN_OK
				invoke EndDialog,hDlg,NULL
			.elseif WORD ptr wParam == IDC_BTN_CANCEL
				invoke SendMessage,hDlg,WM_CLOSE,NULL,NULL
			.elseif WORD ptr wParam == IDC_BTN_DEFAULTS
				invoke GdipSetSolidFillColor,brHighLight.brWord,ARGB_DEFAULT_WHOLEWORD
				invoke GdipSetSolidFillColor,brHighLight.brWordI,ARGB_DEFAULT_WHOLEWORDI
				invoke GdipSetSolidFillColor,brHighLight.brChars,ARGB_DEFAULT_PARTIAL
				invoke GdipSetSolidFillColor,brHighLight.brCharsI,ARGB_DEFAULT_PARTIALI
				invoke SendMessage,hDlg,WM_HSCROLL,SB_THUMBTRACK OR ((ARGB_DEFAULT_WHOLEWORD  SHR 8) AND 0ff0000h),rv(GetDlgItem,hDlg,IDC_SCB_0)
				invoke SendMessage,hDlg,WM_HSCROLL,SB_THUMBTRACK OR ((ARGB_DEFAULT_WHOLEWORDI SHR 8) AND 0ff0000h),rv(GetDlgItem,hDlg,IDC_SCB_1)
				invoke SendMessage,hDlg,WM_HSCROLL,SB_THUMBTRACK OR ((ARGB_DEFAULT_PARTIAL    SHR 8) AND 0ff0000h),rv(GetDlgItem,hDlg,IDC_SCB_2)
				invoke SendMessage,hDlg,WM_HSCROLL,SB_THUMBTRACK OR ((ARGB_DEFAULT_PARTIALI   SHR 8) AND 0ff0000h),rv(GetDlgItem,hDlg,IDC_SCB_3)

			.elseif WORD ptr wParam >= IDC_BTN_0 && WORD ptr wParam <= IDC_BTN_3
				
				movzx edx,WORD ptr wParam
				sub edx,IDC_BTN_0
				lea esi,brHighLight[edx*4]
				invoke GdipGetSolidFillColor,DWORD ptr [esi],ADDR argbColor
				mov edx,argbColor
				bswap edx
				shr edx,8
				mov rgbColor,edx
				push edx
				invoke ColorDlg,hDlg,hInstance,ADDR rgbColor,CC_RGBINIT
				pop edx
				.if edx != rgbColor
					invoke GdipDeleteBrush,DWORD ptr [esi]
					mov edx,rgbColor
					bswap edx
					shr edx,8
					mov ecx,argbColor
					and ecx,0ff000000h
					or edx,ecx
					invoke GdipCreateSolidFill,edx,esi
					invoke InvalidateRect,hDlg,0,1
					mov eax,pAddinData
					invoke SettingsSaveIni,ADDR [eax].ADDINDATA.szRadASMIni
				.endif
			.else
				mov eax,FALSE
				ret
			.endif
		.endif
	.elseif uMsg == WM_CLOSE
		invoke GdipSetSolidFillColor,brHighLight.brWord,brHighLightSave.brWord
		invoke GdipSetSolidFillColor,brHighLight.brWordI,brHighLightSave.brWordI
		invoke GdipSetSolidFillColor,brHighLight.brChars,brHighLightSave.brChars
		invoke GdipSetSolidFillColor,brHighLight.brCharsI,brHighLightSave.brCharsI
		mov eax,pAddinData
		invoke SettingsSaveIni,ADDR [eax].ADDINDATA.szRadASMIni
		invoke EndDialog,hDlg,NULL
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	Ret
DialogProc EndP

align 16
StaticProc proc uses esi ebx edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL hdc:HDC
LOCAL graphics:PVOID
LOCAL rect:RECT
LOCAL rect2:RECT
LOCAL brWhite:PVOID
LOCAL ps:PAINTSTRUCT
LOCAL x:DWORD,y:DWORD
LOCAL hBmp:DWORD

	mov esi,rv(GetWindowLong,hWnd,GWL_USERDATA)
	.if uMsg == WM_PAINT

		invoke BeginPaint,hWnd,ADDR ps
		invoke GetClientRect,hWnd,ADDR rect
		mov hdc,rv(CreateCompatibleDC,ps.hdc)
		mov hBmp,rv(CreateCompatibleBitmap,ps.hdc,rect.right,rect.bottom)
		invoke SelectObject,hdc,eax
		
		invoke GdipCreateFromHDC,hdc,ADDR graphics
		invoke GdipSetPageUnit,graphics,UnitPixel
		invoke GdipGraphicsClear,graphics,0ff747474h
		
		invoke GdipSetPageUnit,graphics,UnitMillimeter

		invoke GdipCreateSolidFill,0ffa1a1a1h,ADDR brWhite

		mov eax,rect.right
		shr eax,1
		mov x,eax
		mov eax,rect.bottom
		shr eax,1
		mov y,eax
			
		xor edi,edi
		xor esi,esi
		.while edi < y
			xor ebx,ebx
			.while ebx < x
				invoke GdipFillRectangleI,graphics,brWhite,ADDR [ebx*4+esi],ADDR [edi*2],2,2
				lea ebx,[ebx+1]
			.endw
			.if esi == 2
				xor esi,esi
			.else
				mov esi,2
			.endif
			lea edi,[edi+1]
		.endw
		invoke GdipSetPageUnit,graphics,UnitPixel
		
		invoke SetBkColor,hdc,0
		invoke SetBkMode,hdc,TRANSPARENT
		invoke GetClientRect,hWnd,ADDR rect
		fn DrawText,hdc,"AbcDef",6,ADDR rect,DT_CENTER or DT_SINGLELINE or DT_VCENTER or DT_CALCRECT
		
		invoke GetClientRect,hWnd,ADDR rect2
		fn DrawText,hdc,"AbcDef",6,ADDR rect2,DT_CENTER or DT_SINGLELINE or DT_VCENTER
		
		mov esi,rv(GetWindowLong,hWnd,GWL_USERDATA)
		mov eax,[esi].STATIC_SUBCALSS.pargbColor
		
		mov edx,rect.right
		mov ecx,rect.bottom
		shr edx,1
		shr ecx,1
		m2m rect.left,rect2.right
		m2m rect.top,rect2.bottom
		shr rect.left,1
		shr rect.top,1
		sub rect.left,edx
		sub rect.top,ecx

		invoke GdipFillRectangleI,graphics,DWORD ptr [eax],rect.left,rect.top,rect.right,rect.bottom

		invoke GdipDeleteBrush,brWhite
		invoke GdipDeleteGraphics,graphics
		
		invoke GetClientRect,hWnd,ADDR rect
		invoke BitBlt,ps.hdc,0,0,rect.right,rect.bottom,hdc,0,0,SRCCOPY
		invoke DeleteObject,hBmp
		invoke DeleteDC,hdc		
		invoke EndPaint,hWnd,ADDR ps
		xor eax,eax
	.else
		invoke CallWindowProc,[esi].STATIC_SUBCALSS.pWndProc,hWnd,uMsg,wParam,lParam
	.endif
	ret
	
StaticProc endp

SettingsLoadIni proc pszIniFilename:dword
	invoke GdipCreateSolidFill,rv(GetPrivateProfileInt,chr$('HIGHLIGHT'),chr$('FullWord'),ARGB_DEFAULT_WHOLEWORD,pszIniFilename),OFFSET brHighLight.brWord
	invoke GdipCreateSolidFill,rv(GetPrivateProfileInt,chr$('HIGHLIGHT'),chr$('FullWordI'),ARGB_DEFAULT_WHOLEWORDI,pszIniFilename),OFFSET brHighLight.brWordI
	invoke GdipCreateSolidFill,rv(GetPrivateProfileInt,chr$('HIGHLIGHT'),chr$('Partial'),ARGB_DEFAULT_PARTIAL,pszIniFilename),OFFSET brHighLight.brChars
	invoke GdipCreateSolidFill,rv(GetPrivateProfileInt,chr$('HIGHLIGHT'),chr$('PartialI'),ARGB_DEFAULT_PARTIALI,pszIniFilename),OFFSET brHighLight.brCharsI
	ret
SettingsLoadIni endp

SettingsSaveIni proc pszIniFilename:dword
LOCAL argbColor:DWORD
	
	invoke GdipGetSolidFillColor,brHighLight.brWord,ADDR argbColor
	invoke WritePrivateProfileString,chr$('HIGHLIGHT'),chr$('FullWord'),udword$(argbColor),pszIniFilename
	invoke GdipGetSolidFillColor,brHighLight.brWordI,ADDR argbColor
	invoke WritePrivateProfileString,chr$('HIGHLIGHT'),chr$('FullWordI'),udword$(argbColor),pszIniFilename
	invoke GdipGetSolidFillColor,brHighLight.brChars,ADDR argbColor
	invoke WritePrivateProfileString,chr$('HIGHLIGHT'),chr$('Partial'),udword$(argbColor),pszIniFilename
	invoke GdipGetSolidFillColor,brHighLight.brCharsI,ADDR argbColor
	invoke WritePrivateProfileString,chr$('HIGHLIGHT'),chr$('PartialI'),udword$(argbColor),pszIniFilename

	ret
SettingsSaveIni endp


ColorDlg proc USES EDI hWin:DWORD, instance:DWORD,lpInitColor:DWORD, Flags:DWORD
	;Common dialog process
	LOCAL ccl:CHOOSECOLOR
	LOCAL crv[16]:DWORD

	lea edi,crv[0]
	mov ecx,16
	mov eax,0FFFFFFh
	rep stosd

	mov ccl.lStructSize,sizeof CHOOSECOLOR
	push hWin
	pop ccl.hwndOwner
	push instance
	pop ccl.hInstance
	mov eax,lpInitColor
	mov	eax,	[eax]
	mov ccl.rgbResult,eax

	; address of 16 item DWORD array
	mov ccl.lpCustColors,OFFSET CustColor
	push Flags
	pop ccl.Flags
	mov ccl.lCustData,0
	mov ccl.lpfnHook,0;OFFSET CCHookProc
	mov ccl.lpTemplateName,0;OFFSET szTemplate

	invoke ChooseColor,addr ccl

	;Is the colordialog canceled
	.if eax!= 0
		mov eax,ccl.rgbResult
		mov	edi, lpInitColor
		mov	[edi],eax
	.endif
	ret
ColorDlg endp


End DllEntry
